SystemOrganization addCategory: #WorkPlayRatioScheduler!

Object subclass: #WorkPlayRatioScheduler
	instanceVariableNames: 'workMin workPerPlayRatio mins schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:02'!
ratio4hour4
|s|
s := WorkPlayRatioScheduler new.
s hours: 4.
s workPerPlayRatio: 4.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:03'!
ratio5hour8
|s|
s := WorkPlayRatioScheduler new.
s hours: 8.
s workPerPlayRatio: 5.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler methodsFor: 'adding' stamp: 'HwaJong 11/23/2012 14:56'!
addEntryToSchedule
schedule addLast: self workPlayEntry! !

!WorkPlayRatioScheduler methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/23/2012 15:00'!
compute
[self addEntryToSchedule.
self reduceMin.
mins > 0]
	whileTrue:
		[self increaseWorkMin].! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
hours: anInteger
self mins: anInteger * 60! !

!WorkPlayRatioScheduler methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/23/2012 14:50'!
increaseWorkMin
workMin := workMin + 1! !

!WorkPlayRatioScheduler methodsFor: 'initialize-release' stamp: 'HwaJong 11/23/2012 14:56'!
initialize 
super initialize.
schedule := OrderedCollection new.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
mins: anInteger
mins := anInteger! !

!WorkPlayRatioScheduler methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/23/2012 14:48'!
playMin
^(workMin / workPerPlayRatio) rounded max: 1! !

!WorkPlayRatioScheduler methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/23/2012 14:50'!
reduceMin
mins := mins - workMin - self playMin.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 15:00'!
schedule
	^ schedule! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin
	^ workMin! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin: anInteger
	workMin := anInteger
! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio
	^ workPerPlayRatio! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio: aNumber
	workPerPlayRatio := aNumber
! !

!WorkPlayRatioScheduler methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/23/2012 14:49'!
workPlayEntry
^{workMin . self playMin}! !
